// =====================================================================
/*!
//
//  \file TInputObjectFilter.hh
//  \brief This file contains the TInputObjectFilter class.
//  \author Go IWAI <goiwai@users.sourceforge.jp>
//
//  $Id: TInputObjectFilter.hh,v 1.3 2004/03/07 10:30:32 goiwai Exp $
//  $Name: CLDAQ-1-14-06 $
//  $Log: TInputObjectFilter.hh,v $
//  Revision 1.3  2004/03/07 10:30:32  goiwai
//  ROOTに組みこむためのおまじないマクロを埋めこみました。
//  全てにおいて完全に動作するわけではありません。
//
//  Revision 1.2  2004/01/19 21:09:41  goiwai
//  プリプロセッサの接頭辞をCLDAQ__に変更しました.
//
//  Revision 1.1  2003/12/06 10:18:15  goiwai
//  入力フィルターと出力フィルターを別扱いにしました.
//  これらは純粋仮想関数Filtering()を含みます.
//
*/
// =====================================================================
#ifndef CLDAQ__TINPUTOBJECTFILTER_HH
#define CLDAQ__TINPUTOBJECTFILTER_HH

#include "Tglobals.h"
#include "TObjectFilter.hh"

class TStreamableObject;
class TInputObjectStream;
class TInputObjectStream;
class TObjectStream;
class TInputObjectFilter;

/*!
// \example
//
// If example code exists.
//
*/

/*!
// \class TInputObjectFilter
// \brief This is the TInputObjectFilter class.
// \author Go IWAI <goiwai@users.sourceforge.jp>
//
// The TInputObjectFilter class detail description.
// Write it down ASAP!
//
// \todo None?
// \bug None?
// \ingroup PersistencyCategory
*/
class TInputObjectFilter
  : public TObjectFilter
{

  public:
    TInputObjectFilter();
    virtual ~TInputObjectFilter();

  public:
    virtual Tint Filtering( TStreamableObject& object, TInputObjectStream* stream ) = 0;
    virtual Tvoid Initialize( TInputObjectStream* stream );
    virtual Tvoid Finalize( TInputObjectStream* stream );

#ifdef __CLDAQ_ROOT_DLL
    ClassDef(TInputObjectFilter,0)
#endif

};

inline Tvoid TInputObjectFilter::Initialize( TInputObjectStream* stream )
{
  return;
}

inline Tvoid TInputObjectFilter::Finalize( TInputObjectStream* stream )
{
  return;
}

#endif
